﻿using System;
using System.Collections.Generic;
using System.IO.Ports;
using System.Linq;
using System.Text;
using System.Threading;
using System.Configuration;
using TCPSerialProxy;
using TCPSerialProxy.Utils;

namespace TCPSPConsole
{
    class Program
    {

        public static AppSettingsReader configurationAppSettings;

        static void Main(string[] args)
        {
            try
            {
                configurationAppSettings = new AppSettingsReader();

                SerialConfig serialConf = new SerialConfig()
                {
                    portName = (string)configurationAppSettings.GetValue("com.portName", typeof(string)),
                    baudRate = (int)configurationAppSettings.GetValue("com.baudRate", typeof(int)),
                    parity = (Parity)Enum.Parse(typeof(Parity), (string)configurationAppSettings.GetValue("com.parity", typeof(string))),
                    dataBits = (int)configurationAppSettings.GetValue("com.dataBits", typeof(int)),
                    stopBits = (StopBits)Enum.Parse(typeof(StopBits), (string)configurationAppSettings.GetValue("com.stopBits", typeof(string))),
                    handshake = (Handshake)Enum.Parse(typeof(Handshake), (string)configurationAppSettings.GetValue("com.handshake", typeof(string))),
                    readTimeout = (int)configurationAppSettings.GetValue("com.readTimeout", typeof(int)),
                    writeTimeout = (int)configurationAppSettings.GetValue("com.writeTimeout", typeof(int)),
                    dummyComMode = (Boolean)configurationAppSettings.GetValue("com.dummyComMode", typeof(Boolean))
                };
                SocketConfig socketConf = new SocketConfig()
                {
                    ipPort = (int)configurationAppSettings.GetValue("tcp.port", typeof(int)),
                    ipBinding = (string)configurationAppSettings.GetValue("tcp.ipBinding", typeof(string))
                };

                SerialProxy serialProxy = new SerialProxy(serialConf, socketConf);
                
            }
            catch (Exception e)
            {
                Console.WriteLine("Unable to Load Settings: " + e.Message);
            }

            while (true)
            {
                Thread.Sleep(1000000);
            }
        }
    }
}
