﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO.Ports;
using TCPSerialProxy.Utils;

namespace TCPSerialProxy
{
    public class SerialProxy
    {
        SerialSocketServer socketServer;
        COMService comService;

        public SerialProxy(SerialConfig serialConf, SocketConfig socketConf)
        {
            comService = InitialiseCOMService(serialConf);
            socketServer = StartServer(comService, socketConf);
        }

        private SerialSocketServer StartServer(COMService _comService, SocketConfig socketConf)
        {
            return new SerialSocketServer(socketConf, _comService);
        }

        private COMService InitialiseCOMService(SerialConfig serialConf)
        {
            return new COMService(serialConf);
        }
    }
}
